#!/usr/bin/env python
# -*- coding: utf-8 -*-
import time
import subprocess
import glob
from lcd_input import HD44780

base_dir = '/sys/bus/w1/devices/'
device_folder = glob.glob(base_dir + '10*')[0]
device_file = device_folder + '/w1_slave'

def temperature():
        def read_temp_raw():
            catdata = subprocess.Popen(['cat',device_file], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            out,err = catdata.communicate()
            out_decode = out.decode('utf-8')
            lines = out_decode.split('\n')
            return lines
            
        lines = read_temp_raw()
        while lines[0].strip()[-3:] != 'YES':
            time.sleep(0.2)
            lines = read_temp_raw()
        equals_pos = lines[1].find('t=')
        if equals_pos != -1:
            temp_string = lines[1][equals_pos+2:]
            temp_c = float('{0:4.1f}'.format(float(temp_string) / 1000.0))        
        lcd.message("Temp: "+str(temp_c)+"C")

if __name__ == '__main__':
    lcd = HD44780()
    time.sleep(0.05)
    lcd.message("   Hello!!!")
    time.sleep(2)
    lcd.cmd(1,False)
    while (1):
      temperature()
      time.sleep(3)
      lcd.cmd(lcd.LCD_RETURNHOME,False)